unit ImpDlgF;

{$I demo.inc}

interface

uses
  Forms, IB_QImport2Wizard, Grids, StdCtrls, Classes, Controls, ExtCtrls,
  IB_QImport2, ComCtrls, Graphics, IB_Components, IB_Grid;

type
  TfmImpDlg = class(TForm)
    QImportWizard1: TIB_QImport2Wizard;
    Panel1: TPanel;
    btImport: TButton;
    chbUseBeforePost: TCheckBox;
    Button1: TButton;
    pcDestinations: TPageControl;
    tshDataSet: TTabSheet;
    dgrDataSet: TIB_Grid;
    tshDBGrid: TTabSheet;
    tshListView: TTabSheet;
    tshStringGrid: TTabSheet;
    DBGrid: TIB_Grid;
    ListView: TListView;
    StringGrid: TStringGrid;
    IB_Connection1: TIB_Connection;
    IB_Query1: TIB_Query;
    IB_DataSource1: TIB_DataSource;
    IB_Query2: TIB_Query;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btImportClick(Sender: TObject);
    procedure QImportWizard1AfterImport(Sender: TObject);
    procedure QImportWizard1BeforePost(Sender: TObject; Row: TQImportRow;
      var Accept: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure pcDestinationsChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fmImpDlg: TfmImpDlg;

implementation

uses SysUtils;

{$R *.DFM}

procedure TfmImpDlg.FormCreate(Sender: TObject);
begin
  IB_Connection1.Database := ExtractFilePath(Application.ExeName) +
    {$IFNDEF DEMO_EXE}'..\..\' +{$ENDIF} 'data\country.gdb';
  IB_Connection1.Username := 'SYSDBA';
  IB_Connection1.Password := 'masterkey';

  IB_Query1.Open;

  StringGrid.Cells[0, 0] := 'Name of Country';
  StringGrid.Cells[1, 0] := 'Capital of Country';
  StringGrid.Cells[2, 0] := 'Continent of Country';
  StringGrid.Cells[3, 0] := 'Area of Country';
  StringGrid.Cells[4, 0] := 'Population of Country';
end;

procedure TfmImpDlg.FormDestroy(Sender: TObject);
begin
  IB_Query1.Close;
end;

procedure TfmImpDlg.btImportClick(Sender: TObject);
begin
  QImportWizard1.Execute;  
end;

procedure TfmImpDlg.QImportWizard1AfterImport(Sender: TObject);
begin
  IB_Query1.RefreshAll;
end;

procedure TfmImpDlg.QImportWizard1BeforePost(Sender: TObject;
  Row: TQImportRow; var Accept: Boolean);
var
  i: integer;
begin
  if chbUseBeforePost.Checked then
    for i := 0 to Row.Count - 1 do
      if AnsiCompareText(Row[i].Value, 'Argentina') = 0 then begin
        Accept := false;
        Exit;
      end;
end;

procedure TfmImpDlg.Button1Click(Sender: TObject);
var
  i, j: integer;
begin
  if (pcDestinations.ActivePage = tshDataSet) or
     (pcDestinations.ActivePage = tshDBGrid) then begin
   IB_Query2.Execute;
   IB_Query1.RefreshAll;
  end
  else if pcDestinations.ActivePage = tshListView then begin
    ListView.Items.BeginUpdate;
    try
      ListView.Items.Clear;
    finally
      ListView.Items.EndUpdate;
    end;
  end
  else if pcDestinations.ActivePage = tshStringGrid then begin
    for i := 1 to StringGrid.RowCount - 1 do
      for j := 0 to StringGrid.ColCount - 1 do
        StringGrid.Cells[j, i] := EmptyStr;
  end;
end;

procedure TfmImpDlg.pcDestinationsChange(Sender: TObject);
begin
  if pcDestinations.ActivePage = tshDataSet then
    QImportWizard1.ImportDestination := qidDataSet
  else if pcDestinations.ActivePage = tshDBGrid then
    QImportWizard1.ImportDestination := qidDBGrid
  else if pcDestinations.ActivePage = tshListView then
    QImportWizard1.ImportDestination := qidListView
  else if pcDestinations.ActivePage = tshStringGrid then
    QImportWizard1.ImportDestination := qidStringGrid;
end;

end.
